% input signal
fs = 44100;
n = 0:48;
x = sin( n*pi / 6 );

% upsampling by 4
v1 = zeros( 1, 4*length(x) );		% insert 3 zeros
v1(1:4:end) = x;

% linear interpolation between 5 samples (triangular)
hi = [ 0.25, 0.5, 0.75, 1.0, 0.75, 0.5, 0.25 ];
[Hi,Fi] = freqz( hi, 1, 8192 );

% linear interpolation
v2 = conv( hi, v1 );				% filter

% linear decimation filter (mean value of 3 samples)
hd = [ 1 1 1 ] / 3;
[Hd,Fd] = freqz( hd, 1, 8192 );

% simple downsampling
w1 = v2(1:3:end);					% every 3rd value

% downsampling with linear decimation (mean value)
w2 = conv( hd, v2 );				% filter
w2 = w2(1:3:end);					% every 3rd value

% plot
figure(3);

[X,Fx] = freqz( x, 1 ,8192,fs);
[W2,Fw2] = freqz( w2, 1 ,8192,4/3*fs);

 plot( Fx, 20*log10(abs( X )) );
 hold on
 plot( Fw2, 20*log10(abs( W2 )) );
 hold off
 
legend('X', 'W_2'); %, 'X-W_2' )
ylim([-40,40])

xlabel( 'f in Hz' );
ylabel( 'Magnitude in dB ' );
